package eu.hsrw.tr.prog.vl.einfuehrung;

/**
 * Beispiel zur Demonstration der Rundungsfehler bei Gleitkommazahlen
 * @author Thomas Richter
 *
 */
public class FloatFehler {

	public static void main(String[] args) {

		float a = 300.1f;
		float b = 400.1f;
		float c = 200.1f;
		float d = 600.1f;
		float e = 10.0f;
		
		
		// Berechnung mit erwartetem Ergebnis: x == 1.0
		// erste Klammer: (300.1 * 400.1 + 10.0 - 200.1 * 600.1)
		// = 120070.01 + 10.0 - 120080.01
		// = 0
		
		// gesamte Berechnung:
		// 400.1 * 0 * 600.1 + (300.1 - 200.1) / (10.0 * 10.0)
		// = 0 + 100.0 / 100.0
		// = 1	
		float x = b * (a * b + e - c * d) * d + (a - c) / (e * e);
		
		// tatsächliches Ergebnis: x == 1876.7812
		System.out.println(x);
	}
}
